require 'crowd_fund/pledge_pool'

module CrowdFund
  describe Pledge do

    before do
      @pledge = Pledge.new(:gold, 100)
    end

    it "has a name attribute" do
      expect(@pledge.name).to eq(:gold)
    end

    it "has a value attribute" do
      expect(@pledge.value).to eq(100)
    end

    describe PledgePool do

      it "has an array with three pledge values" do
        expect(PledgePool::PLEDGES.size).to eq(3)
      end

      it "has a bronze pledge of value $50" do
        expect(PledgePool::PLEDGES[0]).to eq(Pledge.new(:bronze, 50))
      end

      it "has a silver pledge of value $75" do
        expect(PledgePool::PLEDGES[1]).to eq(Pledge.new(:silver, 75))
      end

      it "has a gold pledge of value $100" do
        expect(PledgePool::PLEDGES[2]).to eq(Pledge.new(:gold, 100))
      end
    end

    context "receiving a pledge" do

      it "randomizes a pledge to fund a project" do
        expect(PledgePool::PLEDGES).to include(PledgePool.randomize)
      end
    end

  end
end
