require 'crowd_fund/secure_project'

module CrowdFund
  describe SecureProject do

    before do
      $stdout = StringIO.new
      @amount = 100
      @amount_to_add = 100
      @secure = SecureProject.new("abc", @amount, 1000)
    end

    it "does not match funds when the project is halfway funded" do
      3.times {@secure.add(@amount_to_add)}

      expect(@secure.halfway?).to be_falsey
    end

    it "matches funds when the project is halfway towards the target" do
      4.times {@secure.add(@amount_to_add)}

      expect(@secure.halfway?).to be_truthy
    end

    it "receives a matching fund when it's halfway towards the target" do
      5.times {@secure.add(@amount_to_add)}

      expect(@secure.amount).to eq(@amount + (4 * 100) + 500)
    end
  end
end
